<link rel="import" href="../../bower_components/iron-signals/iron-signals.html">
<link rel="import" href="../../bower_components/paper-dropdown-menu/paper-dropdown-menu.html">
<link rel="import" href="../../bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="../../bower_components/paper-item/paper-item.html">
<link rel="import" href="../../bower_components/paper-item/paper-icon-item.html">

<dom-module id="dez-label-editor">

    <template>
        
        <style>
            app-toolbar {
                background-color: #EFF5FB;
            }
            paper-input, paper-dropdown-menu {
                margin: 30px;
            }
            div.label {
                display: inline-block;
                box-sizing: border-box;
                width: 40px;
                height: 20px;
                border-radius: 10%;
                background: var(--paper-amber-500);
            }
            div.patternA {
                background-color: gray;
            }
            div.patternB {
                background-color: purple;
            }
            div.patternC {
                background-color: magenta;
            }
            div.patternD {
                background-color: maroon;
            }
            div.S {
                background-color: red;
            }
            div.CS1 {
                background-color: blue;
            }
            div.CS2 {
                background-color: green;
            }
        </style>

        <iron-signals on-iron-signal-show-label-to-edit="_handleLabelToEditSignal"></iron-signals>
        <iron-signals on-iron-signal-label-has-changed="_handleLabelHasChangedSignal"></iron-signals>
          <app-toolbar>
              <div main-title></div>
              <template is="dom-if" if={{_mustDisplayLabelData}}>
                  <template is="dom-if" if={{isStaffLabel}}>
                      <paper-dropdown-menu label="Type">
                          <paper-listbox slot="dropdown-content" attr-for-selected="item-name" selected="{{label.type}}" on-selected-changed="_changeType">
                              <paper-icon-item item-name="patternA"><div class="label patternA" slot="item-icon"></div>Pattern A</paper-icon-item>
                              <paper-icon-item item-name="patternB"><div class="label patternB" slot="item-icon"></div>Pattern B</paper-icon-item>
                              <paper-icon-item item-name="patternC"><div class="label patternC" slot="item-icon"></div>Pattern C</paper-icon-item>
                              <paper-icon-item item-name="patternD"><div class="label patternD" slot="item-icon"></div>Pattern D</paper-icon-item>
                              <paper-icon-item item-name="S"><div class="label S" slot="item-icon"></div>Subject</paper-icon-item>
                              <paper-icon-item item-name="CS1"><div class="label CS1" slot="item-icon"></div>Counter-subject 1</paper-icon-item>
                              <paper-icon-item item-name="CS2"><div class="label CS2" slot="item-icon"></div>Counter-subject 2</paper-icon-item>
                          </paper-listbox>
                      </paper-dropdown-menu>
                  </template>
                  <template is="dom-if" if={{typeIsCadence}}>
                      <paper-dropdown-menu label="Type" disabled>
                          <paper-listbox slot="dropdown-content" attr-for-selected="item-name" selected="{{label.type}}">
                              <paper-item item-name="Cad">Cadence</paper-item>
                          </paper-listbox>
                      </paper-dropdown-menu>
                  </template>
                  <template is="dom-if" if={{typeIsStructure}}>
                      <paper-dropdown-menu label="Type" disabled>
                          <paper-listbox slot="dropdown-content" attr-for-selected="item-name" selected="{{label.type}}">
                              <paper-item item-name="Structure">Structure</paper-item>
                              <paper-item item-name="Pedal">Pedal</paper-item>
                          </paper-listbox>
                      </paper-dropdown-menu>
                  </template>
                  <paper-input id="input-start" label="Start" value="{{start}}" size="9" on-value-changed="_changeStart"></paper-input>
                  <template is="dom-if" if={{!typeIsCadence}}>
                      <paper-input id="input-duration" label="Duration" value="{{duration}}" size="8" on-value-changed="_changeDuration"></paper-input>
                  </template>
                  <template is="dom-if" if={{typeIsCadence}}>
                      <paper-input label="Duration" value="0" size="8" disabled></paper-input>
                  </template>
                  <paper-input id="tag-input" label="Tag / comment" value="{{label.tag}}" size="30" on-value-changed="_changeTag"></paper-input>
                  <paper-icon-button icon="backspace" title="delete this label" on-tap="_sendDeleteSignal"></paper-icon-button>
              </template>
          </app-toolbar>
    </template>

    <script>

        Polymer({

            is: 'dez-label-editor',

            properties: {
                target: String
            },

            ready: function () {
                this._mustDisplayLabelData = false;
            },

            _handleLabelToEditSignal: function (e, detail) {
                this._mustDisplayLabelData = true;
                this.label = detail.label;
                // TODO: ugly! must be more generic
                this.isStaffLabel = true;
                this.typeIsCadence = (this.label.type == "Cad")
                this.typeIsStructure = (this.label.type == "Structure") || (this.label.type == "Pedal")
                if (!this.typeIsCadence) {
                    this.duration = scUtils.toDurationMeasureFrac(this.label.duration,4)
                }
                if (this.typeIsCadence || this.typeIsStructure) {
                    this.isStaffLabel = false;
                }
                this.start = scUtils.toMeasureFrac(this.label.start,4)
                this.labelId = detail.id
            },

            _handleLabelHasChangedSignal: function (e, detail) {
                if (detail.sender != this.id) {
                    this.label.start = detail.start;
                    this.label.duration = detail.duration;
                    this.set('start', scUtils.toMeasureFrac(detail.start,4));
                    this.set('duration', scUtils.toDurationMeasureFrac(detail.duration,4));
                }
            },

            _changeLabelData: function () {
                try {
                    this.label.start = scUtils.parseMeasureFrac(this.start,4);
                    if (this.duration != undefined)
                        this.label.duration = scUtils.parseDurationMeasureFrac(this.duration,4);
                    this.fire(
                        'iron-signal',
                        {
                            name: 'label-has-changed',
                            data: {
                                id: this.labelId,
                                start: parseFloat(this.label.start),
                                duration: parseFloat(this.label.duration),
                                type: this.label.type,
                                tag: this.label.tag,
                                sender: this.id
                            }
                        }
                    )
                } catch (exception) {
                    if (exception != "BadFractionalString")
                        console.log(exception);
                }
            },

            _sendDeleteSignal: function () {
              this.fire(
                'iron-signal',
                {
                  name: 'delete-button-pressed',
                  data: {
                      target: this.target
                  }
                }
              );
              this._mustDisplayLabelData = false;
            },

            _changeType: function (event, detail) {
                this.label.type = detail.value;
                this._changeLabelData()
            },

            _changeTag: function (event, detail) {
                this.label.tag = detail.value;
                this._changeLabelData()
            },

            _changeStart: function (event, detail) {
                this.start = detail.value;
                this._changeLabelData()
            },

            _changeDuration: function (event, detail) {
                this.duration = detail.value;
                this._changeLabelData()
            },

        });

    </script>

</dom-module>
